//= require <dSS/grid/ModulatorPanel>
Ext.namespace('dSS', 'dSS.system', 'dSS.grid');

dSS.system.dSMOverview = Ext.extend(Ext.Panel, {
    initComponent: function() {

        Ext.apply(this, {
            layout: 'border',
            items: [
            {
                xtype: 'dssmodulatorpanel',
                ref: 'modulatorPanel',
                region: 'north',
                split: true
            },
            {
                xtype: 'dssdevicepanel',
                ref: 'devicePanel',
                region: 'center',
                featureConfig: dSS.config.FeatureConfig.CIRCUIT
            }]
        });

        dSS.system.dSMOverview.superclass.initComponent.apply(this, arguments);

        this.on('activate', function() {
        	
            var store = dSS.data.Loader.getModulatorStore();
            dSS.util.getControllerStatuses(store);
            var func = dSS.util.getControllerStatuses.bind();
            this.updateControllerStatusesTimer = setInterval(function(){func(store);}, 15000);
            
            this.modulatorPanel.setInitialSelection();

            dSS.MessageBus.fireEvent('reloadbinaryinputs');
            dSS.MessageBus.fireEvent('reloadvdcopstates');
        },
        this);

        this.on('deactivate', function() {
        	clearInterval(this.updateControllerStatusesTimer);
            },
            this);
        this.on('afterrender', function() {
            if (dSS.config.firstLoad === true) {
                var fn = dSS.util.maskViewport.createDelegate(this, [ 'mask' ]);
                fn();
                dSS.data.Loader.load();
                dSS.config.firstLoad = false;
            }
        },
        this);

        dSS.MessageBus.on('reloadapartment',
            dSS.util.maskViewport.createDelegate(this, [ 'mask' ]),
            this);

        dSS.MessageBus.on('structureloaded',
            dSS.util.maskViewport.createDelegate(this, [ 'unmask' ]),
            this);
    }
});

Ext.reg('dsmoverviewpanel', dSS.system.dSMOverview);

