// search for TODOS in the code
// get a GE-TKM for testing
// figure out why the fucking radio group does not work

Ext.namespace("dSS", "dSS.config", "dSS.devprops");

// form *must* react to the submit event and fire a formsubmitted
// event in response; it *must* also fire a formloaded event once all d
// has been received
//
// parameters: dSUID
dSS.devprops.RampTimeConfigForm = Ext.extend(Ext.form.FormPanel, {
    constructor: function(config) {
        this.device = config.device;

        var devInfo = dSS.util.parseProductID(this.device.get('productID'));
        this.deviceType = devInfo[0];

        this.dSUID = this.device.get('dsuid');

        this.addEvents('formsubmitted', 'formloaded', 'formchanged', 'formretry');

        this.loaders = 0;

        this.standardTransition = new Ext.form.RadioGroup(
        {
            columns: 1,
            padding: 5,
            items:
            [
                {
                    boxLabel: dSS._("Fast (100ms)"),
                    inputValue: dSS.config.DimTimeDefaults.FAST,
                    id: dSS.config.DimTimeDefaults.FAST.toString(),
                    name: 'rb_dimtime_' + this.dSUID
                },
                {
                    boxLabel: dSS._("Soft-On (400ms)"),
                    inputValue: dSS.config.DimTimeDefaults.SOFT_ON,
                    id: dSS.config.DimTimeDefaults.SOFT_ON.toString(),
                    name: 'rb_dimtime_' + this.dSUID
                }
            ]
        });
        

        this.custom = new Ext.form.ComboBox({
            x: 0,
            y: 50,
            width: 75,
            typeAhead: false,
            triggerAction: 'all',
            lazyender: true,
            forceSelection: true,
            editable: false,
            disabled: false,
            mode: 'local',
            store: new Ext.data.ArrayStore({
                id: 0,
                fields:
                [
                    'value',
                    'displayText'
                ],
                data:
                [
                    [
                        1000, //0x43,
                        dSS._("1 s")
                    ],
                    [
                        5000, //0x68,
                        dSS._("5 s")
                    ],
                    [
                        10000, //0x78,
                        dSS._("10 s")
                    ],
                    [
                        30400, //0x92,
                        dSS._("30 s")
                    ],
                    [
                        60800, //0xA2,
                        dSS._("1 min")
                    ],
                    [
                        294400, //0xC6,
                        dSS._("5 min")
                    ],
                    [
                        588800, //0xD6,
                        dSS._("10 min")
                    ],
                    [
                        1843200,//0xF1,
                        dSS._("30 min")
                    ]
                ]
            }),
            valueField: 'value',
            displayField: 'displayText'

        });

        Ext.apply(this, {
            bubbleEvents: [ 'formsubmitted', 'formloaded', 'formchanged',
                            'formretry', 'updateshadow' ],
            padding: 5,
            scope: this,
            layout: 'form',
            items:
            [
                {
                    xtype: 'label',
                    text: dSS._("Transition time settings for dimmed outputs " +
                                "on scene calls") + ':'
                },
                {
                    xtype: 'box',
                    height: 10
                },
                {
                    xtype: 'panel',
                    border: false,
                    height: 50,
                    layout: 'hbox',
                    items:
                    [
                        {
                            xtype: 'label',
                            text: dSS._("Standard transition") + ':',
                            width: 130
                        },
                        {
                            xtype: 'panel',
                            border: false,
                            width: 120,
                            items:
                            [
                                this.standardTransition
                            ]
                        }
                    ]
                },
                {
                    xtype: 'box',
                    height: 10
                },
                {
                    xtype: 'panel',
                    border: false,
                    height: 20,
                    layout: 'hbox',
                    items:
                    [
                        {
                            xtype: 'label',
                            text: dSS._("Slow transition") + ':',
                            width: 130
                        },
                        {
                            xtype: 'label',
                            text: "60" + dSS._("s"),
                            width: 93
                        }
                    ]
                },
                {
                    xtype: 'box',
                    height: 10
                },
                {
                    xtype: 'panel',
                    border: false,
                    width: 355,
                    layout: 'hbox',
                    items:
                    [

                        {
                            xtype: 'label',
                            text: dSS._("Custom transition") + ':',
                            width: 130
                        },
                        this.custom
                    ]
                }
            ]
        });

        dSS.devprops.RampTimeConfigForm.superclass.constructor.apply(this, arguments);

        // without this hack validation events were sent out when the panel
        // became visible, although no changes were made by the user
        this.on('afterrender', function() {
                this.resumeEventFunction.defer(1000, this);
            },
            this);

        this.on('loadcomplete', function() {
                this.standardTransition.on('change', function() {
                        this.fireEvent('formchanged');
                    },
                    this);

                this.custom.on('select', function() {
                    this.fireEvent('formchanged');
                    },
                    this);

                this.custom.on('invalid', function() {
                        this.custom.setValue(0x43);
                    },
                    this);
            },
            this);

        this.on('beforedestroy', function() {
                this.closed = true;
            },
            this);

        this.on('dataloaded', function(data) {
                if (this.closed === true) {
                    return;
                }

                if (data.loader === dSS.devprops.Loaders.DIMTIME0) {
                    this.loaders++;

                    if (data.json.ok !== true) {
                        this.standardTransition.markInvalid(dSS._(data.json.message));
                        this.custom.markInvalid(dSS._(data.json.message));
                    } else {
                        this.loadedStandardTiming = data.json.result.up;
                        if (this.loadedStandardTiming < dSS.config.DimTimeDefaults.SOFT_ON) {
                            this.standardTransition.setValue(dSS.config.DimTimeDefaults.FAST.toString(), true);
                        } else {
                            this.standardTransition.setValue(dSS.config.DimTimeDefaults.SOFT_ON.toString(), true);
                        }
                        if ((this.loadedStandardTiming !== dSS.config.DimTimeDefaults.SOFT_ON) &&
                                (this.loadedStandardTiming !== dSS.config.DimTimeDefaults.FAST)) {

                            this.fireEvent('formchanged');
                        }
                    }
                } else if (data.loader === dSS.devprops.Loaders.DIMTIME2) {
                    this.loaders++;
                    if (data.json.ok !== true) {
                        this.standardTransition.markInvalid(dSS._(data.json.message));
                        this.custom.markInvalid(dSS._(data.json.message));
                    } else {
                        this.loadedCustomTiming = data.json.result.up;
                        this.custom.suspendEvents();
                        this.custom.setValue(this.loadedCustomTiming);
                    }
                }

                if (this.loaders >= 2) {
                    this.fireEvent('formloaded', true);
                }
            },
            this);

        this.on('submit', function() {
            if (this.disabled) {
                this.fireEvent('formsubmitted');
                return;
            }

            if (this.getForm().isValid() !== true) {
                Ext.Msg.alert(dSS._("Error"),
                              dSS._("Please correct values in the red " +
                                    "marked fields and try again"));
                this.fireEvent('formretry');
                return;
            }

            var params0 =
            {
                dsuid : this.dSUID,
                dimtimeIndex: 0
            };

            if ((this.standardTransition.getValue() != null) &&
               (this.standardTransition.getValue().getRawValue() != this.loadedStandardTiming)) {
                params0.up = this.standardTransition.getValue().getRawValue();
                params0.down = this.standardTransition.getValue().getRawValue();
                params0.dimtimeIndex = 0;
            }

            var params2 =
            {
                dsuid : this.dSUID,
                dimtimeIndex: 2
            };

            var custom = this.custom.getValue();
            if (custom != this.loadedCustomTiming) {
                params2.up = custom;
                params2.down = custom;
            }

            var request0 =
            {
                url: '/json/device/setTransitionTime',
                params: params0,
                failureMsg: dSS._("Could not save ramp time settings"),
                scope: this
            }

            // no second submission
            if (Object.keys(params2).length === 2) {
                request0.evt = 'formsubmitted';
            }

            if (Object.keys(params0).length > 2) {
                dSS.util.genericRequest.defer(1500, this, [ request0 ]);
            }

            if (Object.keys(params2).length > 2) {
                dSS.util.genericRequest.defer(2000, this,
                [
                    {
                        url: '/json/device/setTransitionTime',
                        params: params2,
                        failureMsg: dSS._("Could not save ramp time settings"),
                        scope: this,
                        evt: 'formsubmitted'
                    }
                ]);
            }

            // nothing to submit
            if ((Object.keys(params0).length === 2) && // 2 default keys
               (Object.keys(params2).length === 2)) {
                this.fireEvent('formsubmitted');
                return;
            }
        },
        this);
    },
    resumeEventFunction: function() {
        this.custom.resumeEvents();
    } 
});

Ext.reg('dssramptimeconfigform', dSS.devprops.RampTimeConfigForm);

